Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## edu.emory.mathcs.backport.java.util.concurrent
Class SynchronousQueue

    java.lang.Object
      java.util.AbstractCollection
          edu.emory.mathcs.backport.java.util.AbstractCollection
              edu.emory.mathcs.backport.java.util.AbstractQueue
                  edu.emory.mathcs.backport.java.util.concurrent.SynchronousQueue

All Implemented Interfaces:
  BlockingQueue, java.util.Collection, Queue, java.io.Serializable

public class SynchronousQueue
extends AbstractQueue
implements BlockingQueue, java.io.Serializable

A blocking queue in which each insert operation must wait for a corresponding remove operation by another thread, and vice versa. A synchronous queue does not have any internal capacity, not even a capacity of one. You cannot `peek` at a synchronous queue because an element is only present when you try to remove it; you cannot insert an element (using any method) unless another thread is trying to remove it; you cannot iterate as there is nothing to iterate. The head of the queue is the element that the first queued inserting thread is trying to add to the queue; if there is no such queued thread then no element is available for removal and `poll()` will return `null`. For purposes of other `Collection` methods (for example `contains`), a `SynchronousQueue` acts as an empty collection. This queue does not permit `null` elements.

Synchronous queues are similar to rendezvous channels used in CSP and Ada. They are well suited for handoff designs, in which an object running in one thread must sync up with an object running in another thread in order to hand it some information, event, or task.

This class supports an optional fairness policy for ordering waiting producer and consumer threads. By default, this ordering is not guaranteed. However, a queue constructed with fairness set to `true` grants threads access in FIFO order. Fairness generally decreases throughput but reduces variability and avoids starvation.

This class and its iterator implement all of the optional methods of the `Collection` and `Iterator` interfaces.

This class is a member of the Java Collections Framework.

Since:
  1.5
Author:
  Doug Lea
See Also:
  Serialized Form

Constructor Summary
`SynchronousQueue()` Creates a `SynchronousQueue` with nonfair access policy.
`SynchronousQueue(boolean fair)` Creates a `SynchronousQueue` with specified fairness policy.

Method Summary
`void` | `clear()` Does nothing.
`boolean` | `contains(java.lang.Object o)` Always returns `false`.
`boolean` | `containsAll(java.util.Collection c)` Returns `false` unless the given collection is empty.
`int` | `drainTo(java.util.Collection c)` Removes all available elements from this queue and adds them to the given collection.
`int` | `drainTo(java.util.Collection c, int maxElements)` Removes at most the given number of available elements from this queue and adds them to the given collection.
`boolean` | `isEmpty()` Always returns `true`.
`java.util.Iterator` | `iterator()` Returns an empty iterator in which `hasNext` always returns `false`.
`boolean` | `offer(java.lang.Object e)` Inserts the specified element into this queue, if another thread is waiting to receive it.
`boolean` | `offer(java.lang.Object e, long timeout, TimeUnit unit)` Inserts the specified element into this queue, waiting if necessary up to the specified wait time for another thread to receive it.
`java.lang.Object` | `peek()` Always returns `null`.
`java.lang.Object` | `poll()` Retrieves and removes the head of this queue, if another thread is currently making an element available.
`java.lang.Object` | `poll(long timeout, TimeUnit unit)` Retrieves and removes the head of this queue, waiting if necessary up to the specified wait time, for another thread to insert it.
`void` | `put(java.lang.Object e)` Adds the specified element to this queue, waiting if necessary for another thread to receive it.
`int` | `remainingCapacity()` Always returns zero.
`boolean` | `remove(java.lang.Object o)` Always returns `false`.
`boolean` | `removeAll(java.util.Collection c)` Always returns `false`.
`boolean` | `retainAll(java.util.Collection c)` Always returns `false`.
`int` | `size()` Always returns zero.
`java.lang.Object` | `take()` Retrieves and removes the head of this queue, waiting if necessary for another thread to insert it.
`java.lang.Object[]` | `toArray()` Returns a zero-length array.
`java.lang.Object[]` | `toArray(java.lang.Object[] a)` Sets the zeroeth element of the specified array to `null` (if the array has non-zero length) and returns it.

Methods inherited from class edu.emory.mathcs.backport.java.util.AbstractQueue
`add, addAll, element, remove`

Methods inherited from class java.util.AbstractCollection
`toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface edu.emory.mathcs.backport.java.util.concurrent.BlockingQueue
`add`

Methods inherited from interface edu.emory.mathcs.backport.java.util.Queue
`element, remove`

Methods inherited from interface java.util.Collection
`addAll, equals, hashCode`

Constructor Detail

### SynchronousQueue

    public SynchronousQueue()

  Creates a `SynchronousQueue` with nonfair access policy.

### SynchronousQueue

    public SynchronousQueue(boolean fair)

  Creates a `SynchronousQueue` with specified fairness policy.

Parameters:
  `fair` - if true, threads contend in FIFO order for access; otherwise the order is unspecified.

Method Detail

### put

    public void put(java.lang.Object e)
             throws java.lang.InterruptedException

  Adds the specified element to this queue, waiting if necessary for another thread to receive it.

  Specified by:
    `put` in interface `BlockingQueue`
  Parameters:
    `e` - the element to add
  Throws:
    `java.lang.InterruptedException` - if interrupted while waiting
    `java.lang.NullPointerException` - if the specified element is null

### offer

    public boolean offer(java.lang.Object e,
                         long timeout,
                         TimeUnit unit)
                  throws java.lang.InterruptedException

  Inserts the specified element into this queue, waiting if necessary up to the specified wait time for another thread to receive it.

  Specified by:
    `offer` in interface `BlockingQueue`
  Parameters:
    `e` - the element to add
    `timeout` - how long to wait before giving up, in units of `unit`
    `unit` - a `TimeUnit` determining how to interpret the `timeout` parameter
  Returns:
    `true` if successful, or `false` if the specified waiting time elapses before a consumer appears.
  Throws:
    `java.lang.InterruptedException` - if interrupted while waiting
    `java.lang.NullPointerException` - if the specified element is null

### take

    public java.lang.Object take()
                          throws java.lang.InterruptedException

  Retrieves and removes the head of this queue, waiting if necessary for another thread to insert it.

  Specified by:
    `take` in interface `BlockingQueue`
  Returns:
    the head of this queue
  Throws:
    `java.lang.InterruptedException` - if interrupted while waiting

### poll

    public java.lang.Object poll(long timeout,
                                 TimeUnit unit)
                          throws java.lang.InterruptedException

  Retrieves and removes the head of this queue, waiting if necessary up to the specified wait time, for another thread to insert it.

  Specified by:
    `poll` in interface `BlockingQueue`
  Parameters:
    `timeout` - how long to wait before giving up, in units of `unit`
    `unit` - a `TimeUnit` determining how to interpret the `timeout` parameter
  Returns:
    the head of this queue, or `null` if the specified waiting time elapses before an element is present.
  Throws:
    `java.lang.InterruptedException` - if interrupted while waiting

### offer

    public boolean offer(java.lang.Object e)

  Inserts the specified element into this queue, if another thread is waiting to receive it.

  Specified by:
    `offer` in interface `BlockingQueue`
  Parameters:
    `e` - the element to add
  Returns:
    `true` if the element was added to this queue, else `false`
  Throws:
    `java.lang.NullPointerException` - if the specified element is null

### poll

    public java.lang.Object poll()

  Retrieves and removes the head of this queue, if another thread is currently making an element available.

  Specified by:
    `poll` in interface `Queue`
  Returns:
    the head of this queue, or `null` if no element is available.

### isEmpty

    public boolean isEmpty()

  Always returns `true`. A `SynchronousQueue` has no internal capacity.

  Specified by:
    `isEmpty` in interface `java.util.Collection`
  Returns:
    `true`

### size

    public int size()

  Always returns zero. A `SynchronousQueue` has no internal capacity.

  Specified by:
    `size` in interface `java.util.Collection`
  Returns:
    zero

### remainingCapacity

    public int remainingCapacity()

  Always returns zero. A `SynchronousQueue` has no internal capacity.

  Specified by:
    `remainingCapacity` in interface `BlockingQueue`
  Returns:
    zero

### clear

    public void clear()

  Does nothing. A `SynchronousQueue` has no internal capacity.

  Specified by:
    `clear` in interface `java.util.Collection`
  Overrides:
    `clear` in class `AbstractQueue`

### contains

    public boolean contains(java.lang.Object o)

  Always returns `false`. A `SynchronousQueue` has no internal capacity.

  Specified by:
    `contains` in interface `BlockingQueue`
  Parameters:
    `o` - object to be checked for containment in this queue
  Returns:
    `false`

### remove

    public boolean remove(java.lang.Object o)

  Always returns `false`. A `SynchronousQueue` has no internal capacity.

  Specified by:
    `remove` in interface `BlockingQueue`
  Parameters:
    `o` - the element to remove
  Returns:
    `false`

### containsAll

    public boolean containsAll(java.util.Collection c)

  Returns `false` unless the given collection is empty. A `SynchronousQueue` has no internal capacity.

  Specified by:
    `containsAll` in interface `java.util.Collection`
  Parameters:
    `c` - the collection
  Returns:
    `false` unless the given collection is empty
  Throws:
    `java.lang.NullPointerException` - if the specified collection is null

### removeAll

    public boolean removeAll(java.util.Collection c)

  Always returns `false`. A `SynchronousQueue` has no internal capacity.

  Specified by:
    `removeAll` in interface `java.util.Collection`
  Parameters:
    `c` - the collection
  Returns:
    `false`

### retainAll

    public boolean retainAll(java.util.Collection c)

  Always returns `false`. A `SynchronousQueue` has no internal capacity.

  Specified by:
    `retainAll` in interface `java.util.Collection`
  Parameters:
    `c` - the collection
  Returns:
    `false`

### peek

    public java.lang.Object peek()

  Always returns `null`. A `SynchronousQueue` does not return elements unless actively waited on.

  Specified by:
    `peek` in interface `Queue`
  Returns:
    `null`

### iterator

    public java.util.Iterator iterator()

  Returns an empty iterator in which `hasNext` always returns `false`.

  Specified by:
    `iterator` in interface `java.util.Collection`
  Returns:
    an empty iterator

### toArray

    public java.lang.Object[] toArray()

  Returns a zero-length array.

  Specified by:
    `toArray` in interface `java.util.Collection`
  Overrides:
    `toArray` in class `AbstractCollection`
  Returns:
    a zero-length array

### toArray

    public java.lang.Object[] toArray(java.lang.Object[] a)

  Sets the zeroeth element of the specified array to `null` (if the array has non-zero length) and returns it.

  Specified by:
    `toArray` in interface `java.util.Collection`
  Overrides:
    `toArray` in class `AbstractCollection`
  Parameters:
    `a` - the array
  Returns:
    the specified array
  Throws:
    `java.lang.NullPointerException` - if the specified array is null

### drainTo

    public int drainTo(java.util.Collection c)

  Description copied from interface: `BlockingQueue`
  Removes all available elements from this queue and adds them to the given collection. This operation may be more efficient than repeatedly polling this queue. A failure encountered while attempting to add elements to collection `c` may result in elements being in neither, either or both collections when the associated exception is thrown. Attempts to drain a queue to itself result in `IllegalArgumentException`. Further, the behavior of this operation is undefined if the specified collection is modified while the operation is in progress.

  Specified by:
    `drainTo` in interface `BlockingQueue`
  Parameters:
    `c` - the collection to transfer elements into
  Returns:
    the number of elements transferred
  Throws:
    `java.lang.UnsupportedOperationException` - if addition of elements is not supported by the specified collection
    `java.lang.ClassCastException` - if the class of an element of this queue prevents it from being added to the specified collection
    `java.lang.NullPointerException` - if the specified collection is null
    `java.lang.IllegalArgumentException` - if the specified collection is this queue, or some property of an element of this queue prevents it from being added to the specified collection

### drainTo

    public int drainTo(java.util.Collection c,
                       int maxElements)

  Description copied from interface: `BlockingQueue`
  Removes at most the given number of available elements from this queue and adds them to the given collection. A failure encountered while attempting to add elements to collection `c` may result in elements being in neither, either or both collections when the associated exception is thrown. Attempts to drain a queue to itself result in `IllegalArgumentException`. Further, the behavior of this operation is undefined if the specified collection is modified while the operation is in progress.

  Specified by:
    `drainTo` in interface `BlockingQueue`
  Parameters:
    `c` - the collection to transfer elements into
    `maxElements` - the maximum number of elements to transfer
  Returns:
    the number of elements transferred
  Throws:
    `java.lang.UnsupportedOperationException` - if addition of elements is not supported by the specified collection
    `java.lang.ClassCastException` - if the class of an element of this queue prevents it from being added to the specified collection
    `java.lang.NullPointerException` - if the specified collection is null
    `java.lang.IllegalArgumentException` - if the specified collection is this queue, or some property of an element of this queue prevents it from being added to the specified collection

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD